import("stdfaust.lib");

top = nentry("top",0,0,1,0.001):si.smoo;
mid = nentry("mid",0,0,1,0.001):si.smoo;
low = nentry("low",0,0,1,0.001):si.smoo;

// Component values
C1 = 0.25*10^-9;
C2 = 20*10^-9;
C3 = 20*10^-9; 

R1 = 250000;
R2 = 1000000;
R3 = 25000;
R4 = 56000;

// Analog transfer function coefficients:
b0=0;
b1 = top*C1*R1 + mid*C3*R3 + low*(C1*R2 + C2*R2) + (C1*R3 + C2*R3);

b2 = top*(C1*C2*R1*R4 + C1*C3*R1*R4) - mid^2*(C1*C3*R3^2 + C2*C3*R3^2) + mid*(C1*C3*R1*R3 + C1*C3*R3^2 + C2*C3*R3^2) + low*(C1*C2*R1*R2 + C1*C2*R2*R4 + C1*C3*R2*R4) + low*mid*(C1*C3*R2*R3 + C2*C3*R2*R3) + (C1*C2*R1*R3 + C1*C2*R3*R4 + C1*C3*R3*R4);

b3 = low*mid*(C1*C2*C3*R1*R2*R3 + C1*C2*C3*R2*R3*R4) - mid^2*(C1*C2*C3*R1*R3^2 + C1*C2*C3*R3^2*R4) + mid*(C1*C2*C3*R1*R3^2 + C1*C2*C3*R3^2*R4) + top*C1*C2*C3*R1*R3*R4 - top*mid*C1*C2*C3*R1*R3*R4 + top*low*C1*C2*C3*R1*R2*R4;

a0 = 1;

a1 = (C1*R1 + C1*R3 + C2*R3 + C2*R4 + C3*R4) + mid*C3*R3 + low*(C1*R2 + C2*R2);

a2 = mid*(C1*C3*R1*R3 - C2*C3*R3*R4 + C1*C3*R3^2 + C2*C3*R3^2) + low*mid*(C1*C3*R2*R3 + C2*C3*R2*R3) - mid^2*(C1*C3*R3^2 + C2*C3*R3^2) + low*(C1*C2*R2*R4 + C1*C2*R1*R2 + C1*C3*R2*R4 + C2*C3*R2*R4) + (C1*C2*R1*R4 + C1*C3*R1*R4 + C1*C2*R3*R4 + C1*C2*R1*R3 + C1*C3*R3*R4 + C2*C3*R3*R4);

a3 = low*mid*(C1*C2*C3*R1*R2*R3 + C1*C2*C3*R2*R3*R4) - mid^2*(C1*C2*C3*R1*R3^2 + C1*C2*C3*R3^2*R4) + mid*(C1*C2*C3*R3^2*R4 + C1*C2*C3*R1*R3^2 - C1*C2*C3*R1*R3*R4) + low*C1*C2*C3*R1*R2*R4 + C1*C2*C3*R1*R3*R4;

process =
//   UI input
_ : fi.tf3slf(b3,b2,b1,b0,a3,a2,a1,a0) : _;
